Subject: Re: PROBLEM: Broken or delayed ethernet on Xilinx ZCU104 since 5.18 (regression)

From: "Russell King (Oracle)" <[email-masked]>
Date: Fri, 4 Aug 2023 17:47:56 +0100

On Fri, Aug 04, 2023 at 12:24:02PM -0400, Nick Bowler wrote:
> On 04/08/2023, Rob Herring <[email-masked]> wrote:
> > On Fri, Aug 4, 2023 at 9:27 AM Nick Bowler <[email-masked]> wrote:
> >>   commit e461bd6f43f4e568f7436a8b6bc21c4ce6914c36
> >>   Author: Robert Hancock <[email-masked]>
> >>   Date:   Thu Jan 27 10:37:36 2022 -0600
> >>
> >>       arm64: dts: zynqmp: Added GEM reset definitions
> >>
> >> Reverting this fixes the problem on 5.18.  Reverting this fixes the
> >> problem on 6.1.  Reverting this fixes the problem on 6.4.  In all of
> >> these versions, with this change reverted, the network device appears
> >> without delay.
> >
> > With the above change, the kernel is going to be waiting for the reset
> > driver which either didn't exist or wasn't enabled in your config
> > (maybe kconfig needs to be tweaked to enable it automatically).
> 
> The dts defines a reset-controller node with
> 
>   compatible = "xlnx,zynqmp-reset"
> 
> As far as I can see, this is supposed to be handled by the code in
> drivers/reset/zynqmp-reset.c driver, it is enabled by CONFIG_ARCH_ZYNQMP,
> and I have that set to "y", and it appears to be getting compiled in (that
> is, there is a drivers/reset/zynqmp-reset.o file in the build directory).

Isn't the driver called reset-zynqmp.c and reset-zynqmp.o ?

> However, unlike with the other firmware devices, I do not see this driver
> under /sys/bus/platform/drivers, and there is no "driver" symlink under
> /sys/bus/platform/devices/firmware:zynqmp-firmware:reset-controller

The driver name would be the kbuild modname, which would be
reset-zynqmp rather than zynqmp-reset - given how often you're typing
zynqmp-reset rather than zynqmp-reset, could you have missed it
through looking for the wrong name?

If the driver is built-in, there is no reason it should fail to show
up in /sys/bus/platform/drivers/reset-zynqmp.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!